pipeline {
 agent any
  environment {
    dockerimagename = "houcemserver/mynodejs"
    dockerImage = ""
  }
  
 
 
 stages {
     
  stage('Clone') {
      
    steps {
      git branch: 'main', url: 'https://gitlab.com/houcemkhlifi.devops/my-node-projet.git'
    }
    
  }
  
   stage('Build Image') {
    steps {
      script {
          dockerImage = docker.build dockerimagename
        }
    }
  }

  stage('Push Image') {
      
       environment {
               registryCredential = 'dockerid'
           }
           
      steps{
          
        script {
            
          docker.withRegistry( 'https://registry.hub.docker.com', registryCredential ) {
            dockerImage.push("$BUILD_NUMBER")
          }
        }
      }
      
  }
      stage('RUN Image') {
      steps{
          
        script {
      
      // This step should not normally be used in your script. Consult the inline help for details.
       withDockerServer([uri: 'unix:///var/run/docker.sock ']) {
           sh 'docker rmi -f $dockerimagename'
           sh 'docker rm -f myct'
        sh 'docker run -d --name myct -p 5757:3000 $dockerimagename:$BUILD_NUMBER'
   }
 
      }
  
       }
      }
 }
 
}
  
